<?php

App::uses('EvBasketAppController', 'EvBasket.Controller');

class BasketController extends EvBasketAppController {

	public function beforeFilter() {
		parent::beforeFilter();

		$this->Auth->allow(
			array(
				'index',
				'add',
				'remove'
			)
		);
	}

	/**
	 * main basket page
	 *
	 */
	public function index() {
		$this->view = 'EvBasket./Fallbacks/Basket/index';

		$pageId = Configure::read('EvBasket.pageId');

		// check if we have a specific content page set
		// if so - set the template
		if (! empty($pageId)) {
			$pageData = $this->assignPage($pageId);

			if (! empty($pageData)) {
				$this->view = $this->Tpl->getTemplate($pageData, 'Page');
			}
		}

		$this->set(
			'basket',
			$this->BasketManager->getBasket()
		);
	}

	/**
	 * delete an item from your basket (if valid)
	 * and redirect back to previous page
	 */
	public function remove($id) {
		$basketItem = $this->BasketManager->getBasketItem($id);

		$itemData = array(
			'model' => $basketItem['model'],
			'model_id' => $basketItem['model_id']
		);
		if ($this->BasketManager->deleteItem($itemData)) {
			$this->Flash->success(
				Configure::read('EvBasket.redirects.remove.success')
			);
		} else {
			$this->Flash->fail(
				Configure::read('EvBasket.redirects.remove.fail')
			);
		}

		if (Configure::read('EvBasket.redirects.delete') === 'basket') {
			$redirect = array(
				'action' => 'index'
			);
		} else {
			$redirect = $this->referer();
		}

		$this->redirect(
			$redirect
		);
	}

	public function add() {
		// manually add some stuff so i can test
		die('not yet');

		debug(
			$this->BasketManager->addItem(
				array(
					'model' => 'EvShop.Variant',
					'model_id' => 16
				),
				69.540000,
				1
			)
		);

		die();
	}
}
